poj 3126 Prime Path bfs

参考题解的 http://user.qzone.qq.com/289065406/blog/1303623014
题目http://poj.org/problem?id=3126
Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input

3
1033 8179
1373 8017
1033 1033
Sample Output

6
7
0

大致题意:
给定两个四位素数a b,要求把a变换到b
变换的过程要保证 每次变换出来的数都是一个 四位素数,而且当前这步的变换所得的素数 与 前一步得到的素数 只能有一个位不同,而且每步得到的素数都不能重复。

求从a到b最少需要的变换次数。无法变换则输出Impossible

#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<iostream>
#include<queue>

using namespace std;
using namespace std;
queue<struct node>que;

struct node
{
    int prime;
    int step;
};

int n,m;
int vis[15000];
int   prim(int digit)
{
    if(digit==2 || digit==3)
        return 1;
    else if(digit<=1 || digit%2==0)
        return 0;
    else if(digit>3)
    {
        for(int i=3; i*i<=digit; i+=2)
            if(digit%i==0)
                return 0;
        return 1;
    }
}

int  bfs()
{
    int i;
    struct node k;
    while(!que.empty())
        que.pop();
    k.prime=n;
    k.step=0;
    que.push(k);
    vis[n]=1;
    while(!que.empty())
    {
        struct node s=que.front();
        que.pop();
        if(s.prime==m)
        {
            printf("%d\n",s.step);
            return 0;
        }
        int x=s.prime%10;//获得个位
        int y=(s.prime/10)%10;//获得十位
        for(i=1; i<=9; i+=2)
        {
            int a=(s.prime/10)*10+i;
            if(a!=s.prime&&!vis[a]&&prim(a))
            {
                vis[a]=1;
                k.prime=a;
                k.step=s.step+1;
                que.push(k);
            }
        }
        for(i=0; i<=9; i++)   //枚举十位
        {
            int a=(s.prime/100)*100+i*10+x;
            if(a!=s.prime && !vis[a] &&prim(a))
            {
                vis[a]=1;
                k.prime=a;
                k.step=s.step+1;
                que.push(k);
            }
        }

        for(i=0; i<=9; i++) //枚举百位
        {
            int a=(s.prime/1000)*1000+i*100+y*10+x;
            if(a!=s.prime&&vis[a]==0&&prim(a))
            {
                vis[a]=1;
                k.prime=a;
                k.step=s.step+1;
                que.push(k);
            }
        }
        for(i=1; i<=9; i++)   //枚举的千位,保证四位数,千位最少为1
        {
            int a=s.prime%1000+i*1000;
            if(a!=s.prime && !vis[a] && prim(a))
            {
                vis[a]=1;
                k.prime=a;
                k.step=s.step+1;
                que.push(k);
            }
        }
    }
    printf("Impossible\n");
    return 0;
}
int  main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d %d",&n,&m);
        memset(vis,0,sizeof(vis));
        bfs();
    }
    return 0;
}

g++过了,c++CE

    原文作者:B树
    原文地址: https://blog.csdn.net/aonaigayiximasi/article/details/48789743
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞